#pragma once

#include "includes.h"

//BADASS GLOBALS

//======================RELATING TO GLOBALS=========================

typedef struct _HaedGlobalinfo
{
	//the current widget containing an object
	GtkWidget *levelEditorSelectedSideBarWidget;
	//the current unit selected
	EksParent *levelEditorSelectedUnits;
	//the current button clicked in the triggers
	GtkWidget *triggerEditorCurrentButton;
	
	HaedProgramInfo *firstProgram;
	
	TriggerHandler *triggerHandler;
}HaedGlobalinfo;

#ifdef  MAIN_FILE

HaedGlobalinfo HAED_GLOBAL_INFORMATION={0};
#else
extern HaedGlobalinfo HAED_GLOBAL_INFORMATION;
#endif

//======================RELATING TO TRIGGERS======================

//conditions
#define _AO_COLLISION_ "COLLISION"
#define _AO_COUNT_ "COUNT"

#define _SPECIAL_TIMER_ "TIMER_IS"
#define _SPECIAL_C_COMMAND_ "%"

//actions
#define _AO_STOP_ "STOP"
#define _AO_DESTROY_ "DESTROY"
#define _AO_BOUNCE_ "BOUNCE"
#define _AO_SETX_ "SET_X"
#define _AO_SETY_ "SET_Y"
#define _AO_CREATE_ "CREATE_INSTANT_OBJECT"

#define _SET_LEVEL_ "SET_LEVEL"
#define _RESTART_PROGRAM_ "RESTART_PROGRAM"
#define _RESTART_LEVEL_ "RESTART_LEVEL"
#define _NEXT_LEVEL_ "NEXT_LEVEL"

//======================DEFINITION OF OBJECTS=====================

#ifdef  MAIN_FILE
const char *TRIGGERS_SPECIAL_S="SpecialConditions";
const char *TRIGGERS_SOUND_S="SoundConditions";
const char *TRIGGERS_STORY_S="StoryConditions";
const char *TRIGGERS_INPUT_S="InputConditions";

const char *ACTIVE_OBJECT_S="active";
const char *BACKDROP_OBJECT_S="BackdropObject";
#endif

//animations
#define GLOBAL_ANIMATION_STOPPED "stopped"
#define GLOBAL_ANIMATION_RUNNING "running"
#define GLOBAL_ANIMATION_DISAPPEARING "disappearing"
#define GLOBAL_ANIMATION_JUMPING "jumping"

#ifdef  MAIN_FILE
const char *GLOBAL_ANIMATION_VECTOR[4]={GLOBAL_ANIMATION_STOPPED,GLOBAL_ANIMATION_RUNNING,GLOBAL_ANIMATION_DISAPPEARING,GLOBAL_ANIMATION_JUMPING};
#endif

#define GLOBAL_ANIMATION_VECTOR_LEN (sizeof(GLOBAL_ANIMATION_VECTOR)/sizeof(GLOBAL_ANIMATION_VECTOR[0]))


//TEMP!!!
#define HAED_GLOBAL_TRIGGER_HANDLER HAED_GLOBAL_INFORMATION.triggerHandler
#define GLOBAL_TRIGGER_PARENT eks_parent_get_child_from_name(haed_programinfo_get_current_level(HAED_GLOBAL_INFORMATION.firstProgram->program),"triggers")


#ifdef  MAIN_FILE
//Program screen width
int SCREEN_WIDTH=1024;
//Program screen height
int SCREEN_HEIGHT=768;

int MARGIN_SCREEN_WIDTH=100;
int MARGIN_SCREEN_HEIGHT=100;

int MARGIN_SCREEN_WIDTH_MIN=50;
int MARGIN_SCREEN_HEIGHT_MIN=50;

double PLACER_SCREEN_RANGE_X=0;
double PLACER_SCREEN_RANGE_Y=0;

//======================ALL IMPORTANT TOPLEVEL WIDGETS=====================

GtkWidget *MAIN_WINDOW;

//MAIN GIRD
GtkWidget *MAIN_Box;

//MENU ITEMS
GtkWidget *MAIN_menu;

//MID SECT WIDGETS
//GtkWidget *MAIN_MidSectWidgets;

GtkWidget *HAED_GLOBAL_STORY_BOARD=NULL;
GtkWidget *MAIN_StoryBoard=NULL;
	GtkWidget *MAIN_StoryBoard_Info[3];
	
GtkWidget *MAIN_LevelEditor;
	GtkWidget *MAIN_LevelEditor_Scrollbars[3];
	GtkWidget *HAED_GLOBAL_LIST_OBJECTS=NULL;
	GtkWidget *MAIN_LevelEditor_InnerBox=NULL;
	GtkWidget *MAIN_LevelEditor_ListObjects;
	GtkWidget **MAIN_LevelEditor_ListObjectsIconsImage;
	
	GtkWidget *GLOBAL_LEVEL_EDITOR_DRAWING_AREA;
	GtkAdjustment *MAIN_LAYOUT_aX;
	GtkAdjustment *MAIN_LAYOUT_aY;
	
	GtkWidget *MAIN_ActiveObjectMenu=NULL;

GtkWidget *HAED_GLOBAL_TRIGGER_BOX=NULL;
	GtkWidget *HAED_GLOBAL_TRIGGER_GRID=NULL;
	GtkWidget *MAIN_LeftTopInfo;
	
	GtkWidget *listFunctions[2];
	
	GtkWidget *MAIN_ActiveObjectMenuTriggers[20];
	GtkWidget *MAIN_ActiveObjectActionsMenu[20];

GtkWidget *MAIN_Notebook;

//conditions box (or grid)
GtkWidget *ConWindow;
GtkWidget *MAIN_ConditionsBox;

//for the window getobjbox
GtkWidget *MAIN_GetObjBox;

EksParent *HAED_GLOBAL_TEMP_HAEDOBJECT;

int CURRENT_WINDOW_MODE=0;

char *GLOBAL_CURRENT_FILE_NAME=NULL;
#else

//BLERP

extern const char *TRIGGERS_SPECIAL_S;
extern const char *TRIGGERS_SOUND_S;
extern const char *TRIGGERS_STORY_S;
extern const char *TRIGGERS_INPUT_S;
extern const char *ACTIVE_OBJECT_S;
extern const char *BACKDROP_OBJECT_S;

extern const char *GLOBAL_ANIMATION_VECTOR[4];

extern int SCREEN_WIDTH;
extern int SCREEN_HEIGHT;

extern int MARGIN_SCREEN_WIDTH;
extern int MARGIN_SCREEN_HEIGHT;

extern int MARGIN_SCREEN_WIDTH_MIN;
extern int MARGIN_SCREEN_HEIGHT_MIN;

extern double PLACER_SCREEN_RANGE_X;
extern double PLACER_SCREEN_RANGE_Y;

extern GtkWidget *MAIN_WINDOW;
extern GtkWidget *MAIN_Box;

extern GtkWidget *MAIN_menu;

//extern GtkWidget *MAIN_MidSectWidgets;

extern GtkWidget *HAED_GLOBAL_STORY_BOARD;
extern GtkWidget *MAIN_StoryBoard;
	extern GtkWidget *MAIN_StoryBoard_Info[3];
	extern GtkWidget **LevelEditor_previews;
	
extern GtkWidget *MAIN_LevelEditor;
	extern GtkWidget *MAIN_LevelEditor_Scrollbars[3];
	extern GtkWidget *HAED_GLOBAL_LIST_OBJECTS;
	extern GtkWidget *MAIN_LevelEditor_InnerBox;
	extern GtkWidget *MAIN_LevelEditor_ListObjects;
	extern GtkWidget **MAIN_LevelEditor_ListObjectsIconsImage;
	
	extern GtkWidget *GLOBAL_LEVEL_EDITOR_DRAWING_AREA;
	extern GtkAdjustment *MAIN_LAYOUT_aX;
	extern GtkAdjustment *MAIN_LAYOUT_aY;
	
	extern GtkWidget *MAIN_ActiveObjectMenu;

extern GtkWidget *HAED_GLOBAL_TRIGGER_BOX;
	extern GtkWidget *HAED_GLOBAL_TRIGGER_GRID;
	extern GtkWidget *MAIN_LeftTopInfo;
	
	extern GtkWidget *listFunctions[2];
	
	extern GtkWidget *MAIN_ActiveObjectMenuTriggers[20];
	extern GtkWidget *MAIN_ActiveObjectActionsMenu[20];

extern GtkWidget *MAIN_Notebook;

extern GtkWidget *ConWindow;
extern GtkWidget *MAIN_ConditionsBox;

extern GtkWidget *MAIN_GetObjBox;

extern EksParent *HAED_GLOBAL_TEMP_HAEDOBJECT;

extern int CURRENT_WINDOW_MODE;

extern char *GLOBAL_CURRENT_FILE_NAME;
#endif

//======GLOBAL FUNCTIONS======

int haed_animations_get_pos(char *animationname);

uint8_t haed_animations_is_animation(char *animationname);

//====FOR HAEDGLOBALINFO====

void haed_globalinfo_add_program(HaedGlobalinfo *thisinfo,const char *programname);

HaedProgramInfo *haed_globalinfo_get_program_from_position(HaedGlobalinfo *thisinfo,int position);

HaedProgramInfo *haed_globalinfo_get_program_from_name(HaedGlobalinfo *thisinfo,char *findname);
